<script lang="ts">
    import { createEventDispatcher, onMount } from 'svelte'
    import type { IdentifiedError } from './'

    export let error: IdentifiedError

    const dispatch = createEventDispatcher()
    const TIMEOUT = 5000

    onMount(() => {
        setTimeout(() => {
            dispatch('click')
        }, TIMEOUT)
    })
</script>

<svelte:options immutable />

<div class="error">
    <div class="icon">
        <svg fill="none" viewBox="0 0 24 24">
            <path
                stroke="currentColor"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="1.5"
                d="M4.75 12C4.75 7.99594 7.99594 4.75 12 4.75V4.75C16.0041 4.75 19.25 7.99594 19.25 12V12C19.25 16.0041 16.0041 19.25 12 19.25V19.25C7.99594 19.25 4.75 16.0041 4.75 12V12Z"
            />
            <path
                stroke="currentColor"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="1.5"
                d="M9.75 9.75L14.25 14.25"
            />
            <path
                stroke="currentColor"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="1.5"
                d="M14.25 9.75L9.75 14.25"
            />
        </svg>
    </div>
    <div class="body">
        <p class="title">
            {error.name}
        </p>
        {#if error.message}
            <p class="content">{@html error.message}</p>
        {/if}
    </div>
    <div class="close">
        <button on:click>
            <span class="sr-label">Close</span>
            <svg fill="none" viewBox="0 0 24 24">
                <path
                    stroke="currentColor"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="1.5"
                    d="M17.25 6.75L6.75 17.25"
                />
                <path
                    stroke="currentColor"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="1.5"
                    d="M6.75 6.75L17.25 17.25"
                />
            </svg>
        </button>
    </div>
</div>

<style lang="postcss">
    .error {
        @apply w-full flex items-start bg-red-100 shadow-lg rounded-lg pointer-events-auto p-4 ring-1 ring-black ring-opacity-5 overflow-hidden;

        .icon {
            @apply flex-shrink-0;

            svg {
                @apply h-6 w-6 text-red-400;
            }
        }

        .body {
            @apply ml-3 w-0 flex-1 pt-0.5;

            .title {
                @apply text-sm font-medium text-gray-900;
            }

            .content {
                @apply mt-1 text-sm text-gray-500;
            }
        }

        .close {
            @apply ml-4 flex-shrink-0 flex;

            button {
                @apply bg-transparent text-gray-800 rounded-md inline-flex;

                &:hover {
                    @apply text-gray-500;
                }
                &:focus {
                    @apply outline-none ring-2 ring-offset-2 ring-indigo-500;
                }

                .sr-label {
                    @apply sr-only;
                }

                svg {
                    @apply h-5 w-5;
                }
            }
        }
    }
</style>
